/**
 * MercuryAccordion
 * - 01 - Drupal Behaviors
 */

((Drupal, once, MercuryAccordion) => {

  /*------------------------------------*\
    01 - Drupal Behaviors
  \*------------------------------------*/

  /**
   * Drupal specific behaviors for the Mercury Accordion component.
   */
  Drupal.behaviors.MercuryAccordion = {

    /**
     * Attach behaviors for the Mercury Accordion component.
     *
     * @param {Document, HTMLElement} context
     *  The context in which to attach the behaviors.
     */
    attach(context) {
      once('me-accordion', '.me-accordion', context).forEach(accordion => {
        new MercuryAccordion(accordion);
      });
    },

    /**
     * Detach behaviors for the Mercury Accordion component.
     *
     * @param {Document, HTMLElement} context
     *  The context from which to detach the behaviors.
     */
    detach(context) {
      context.querySelectorAll('.me-accordion').forEach(accordion => {
        if (accordion.MercuryAccordion) {
          accordion.MercuryAccordion.destroy();
        }
      });

      // Expand or collapse all accordions based on their stored state.
      // This is necessary to ensure consistency accross page rerenders.
      MercuryAccordion.updateUi();
    }
  };
})(Drupal, once, MercuryAccordion);
