/**
 * Components - MercuryTabs
 * - 01 - Drupal Behaviors
 */

((Drupal, once, MercuryTabs) => {

  /*------------------------------------*\
    01 - Drupal Behaviors
  \*------------------------------------*/

  /**
   * Drupal specific behaviors for the Mercury Tabs component.
   */
  Drupal.behaviors.MercuryTabs = {

    /**
     * Attach behaviors for the Mercury Tabs component.
     *
     * @param {Document, HTMLElement} context
     *  The context in which to attach the behaviors.
     */
    attach(context) {
      once('me-tabs', '.me-tabs', context).forEach(tabGroup => {
        new MercuryTabs(tabGroup);
      });
      // Open any tabs set in the url.
      MercuryTabs.openTabFromHash();
    },

    /**
     * Detach behaviors for the Mercury Tabs component.
     *
     * @param {Document, HTMLElement} context
     *  The context from which to detach the behaviors.
     */
    detach(context) {
      context.querySelectorAll('.me-tabs').forEach(tabs => {
        if (tabs.MercuryTabs) {
          tabs.MercuryTabs.destroy();
        }
      });
    }
  };
})(Drupal, once, MercuryTabs);
